// Solution author: Igor E. Tuphanov
// Algorithm : heap

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#pragma comment(linker, "/stack:10000000")

const int maxn = 200001;

int k,n,m,hs,ans,j;
int u[2*maxn],v[2*maxn],next[2*maxn];
int g[maxn],dep[maxn],vis[maxn],mlev[maxn],par[maxn],mchi[maxn];
int h[maxn];

void Swap(int &i, int &j) 
{
   int tmp = i; i = j; j = tmp;
};

void Add(int i)
{
   next[i] = g[u[i]]; g[u[i]] = i;
};

void Dfs(int x, int y, int fr)
{
   vis[x] = 1; dep[x] = y; par[x] = fr; mchi[x] = x;
   int i = g[x], t = 1;
   while (i != 0) {
      if (!vis[v[i]]) {
         Dfs(v[i],y+1,x);
         if (mlev[v[i]] + 1 > t) {
            t = mlev[v[i]] + 1; mchi[x] = mchi[v[i]];
         };   
      };
      i = next[i];
   };
   mlev[x] = t;
};

void SD(int i)
{
   int l = i*2, r = i*2+1, s = i;
   if (l <= hs && mlev[h[l]] > mlev[h[i]]) s = l;
   if (r <= hs && mlev[h[r]] > mlev[h[s]]) s = r;
   if (s != i) { Swap(h[i],h[s]); SD(s); }
};

int ExMin()
{
   int k = h[1]; 
   Swap(h[1],h[hs]); hs--; SD(1);
   return k; 
}

void AddHeap(int x)
{
   int i = ++hs; h[hs] = x;
   while (i > 1) {
      if (mlev[h[i/2]] > mlev[h[i]]) break;
      Swap(h[i],h[i/2]); i /= 2;
   };
};

void GoUp(int x, int fr)
{
   int i = g[x];
   while (i != 0) {
      if (v[i] != fr && v[i] != par[x]) AddHeap(v[i]);
      i = next[i];
   };
   if (x == j) return;
   GoUp(par[x],x);   
};

int main(void)
{
   int i;
   
   freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
   scanf("%d%d",&n,&k); m = n-1;
   memset(g,0,sizeof(g));
   for (i = 1; i < n; i++){
      scanf("%d%d",&u[i],&v[i]); u[m+i] = v[i]; v[m+i] = u[i];
      Add(i); Add(m+i);
   };
   
   memset(vis,0,sizeof(vis));
   Dfs(1,0,0);
   
   i = g[1]; hs = 0;
   while (i != 0) {
      hs++; h[hs] = v[i];
      i = next[i];
   };
   for (i = hs; i > 0; i--) SD(i);   
   
   ans = 1;
   for (i = 1; i <= k; i++) {
      if (hs == 0) break;
      j = ExMin(); ans += mlev[j];
      GoUp(mchi[j],0);
    };
   
   printf("%d",ans);   
   fclose(stdin); fclose(stdout);
   return 0;
};